//////////////////////////////////////////////////////////////////////////////
// LCG 
//
// Last update: 15/07/2009
//////////////////////////////////////////////////////////////////////////////
import java.lang.String;
import java.lang.Float;
import java.util.regex.Pattern;
import java.math.BigInteger;
import java.math.BigDecimal;
import javax.swing.JApplet;
import netscape.javascript.JSObject;
import netscape.javascript.JSException;

public class LCG extends JApplet
{
    private JSObject window;
    private JSObject document;
    private boolean isLiveConnectOK = true;
    
    public void init()
    {
        super.init();

        // JavaScript Live Connect
        // Get references to HTML textfields via JavaScript        
        try
        {
           window = (JSObject) JSObject.getWindow(this); // this = applet
        } 
        catch(JSException jse) 
        {
           jse.printStackTrace();
           System.out.println(jse.getWrappedException().toString());           
           isLiveConnectOK = false;
           System.out.println("JSException ...");
        } 
        catch (Exception e) 
        {
           e.printStackTrace();
        }                	

        if (window != null)
        {
            window.eval("isAppletOK = true");
        }
	else
	{
    	    System.out.println("LCG: unable to connect to browser!");
        }
    }

    public String LCGint(String m_str, String a_str, String c_str, String s_str)
    {
	    BigInteger m_bi = new BigInteger(m_str);
	    BigInteger a_bi = new BigInteger(a_str);
	    BigInteger c_bi = new BigInteger(c_str);
	    BigInteger s_bi = new BigInteger(s_str);
	    BigInteger v_bi = new BigInteger(s_str);

	    v_bi = v_bi.multiply(a_bi);
	    v_bi = v_bi.add(c_bi);

            BigInteger r_bi = new BigInteger(v_bi.toString());
            r_bi = r_bi.mod(m_bi);
	    return(v_bi.toString() + " " + r_bi.toString());
    }

    public String LCGfloat(String m_str, String a_str, String c_str, String s_str)
    {
	    BigInteger m_bi = new BigInteger(m_str);
	    BigInteger a_bi = new BigInteger(a_str);
	    BigInteger c_bi = new BigInteger(c_str);
	    BigInteger s_bi = new BigInteger(s_str);
	    BigInteger v_bi = new BigInteger(s_str);

	    v_bi = v_bi.multiply(a_bi);
	    v_bi = v_bi.add(c_bi);

            BigInteger r_bi = new BigInteger(v_bi.toString());
            r_bi = r_bi.mod(m_bi);
	    // System.out.println(r_bi.toString() + ", ");

	    BigDecimal num_bd = new BigDecimal(r_bi);
	    BigDecimal den_bd = new BigDecimal(m_bi);
	    BigDecimal res_bd = new BigDecimal(r_bi);
	    res_bd = res_bd.divide(den_bd, 20, BigDecimal.ROUND_HALF_UP);
	    // System.out.println(Float.toString(res_bd.floatValue()) + ",");

	    return(r_bi.toString() + " " + Float.toString(res_bd.floatValue()));
    }
}
